<?php

declare(strict_types=1);

/**
 * vim:set softtabstop=4 shiftwidth=4 expandtab:
 *
 * LICENSE: GNU Affero General Public License, version 3 (AGPL-3.0-or-later)
 * Copyright Ampache.org, 2001-2024
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

namespace Ampache\Module\System\Update\Migration\V7;

use Ampache\Module\System\Update\Migration\AbstractMigration;

final class Migration700011 extends AbstractMigration
{
    protected array $changelog = [
        'Drop `clip` table',
        'Drop `movie` table',
        'Drop `personal_video` table',
        'Drop `tvshow` table',
        'Drop `tvshow_episode` table',
        'Drop `tvshow_season` table',
    ];

    public function migrate(): void
    {
        $this->updateDatabase('DROP TABLE IF EXISTS `clip`;');
        $this->updateDatabase('DROP TABLE IF EXISTS `movie`;');
        $this->updateDatabase('DROP TABLE IF EXISTS `personal_video`;');
        $this->updateDatabase('DROP TABLE IF EXISTS `tvshow`;');
        $this->updateDatabase('DROP TABLE IF EXISTS `tvshow_episode`;');
        $this->updateDatabase('DROP TABLE IF EXISTS `tvshow_season`;');
    }
}
